# Class AutocompleteOptionsFromMethodDirective<Value, Parameters>

#### Type Parameters

- Value = any
- Parameters extends AutocompleteOptionsFromMethodDirectiveParameters<Value> = AutocompleteOptionsFromMethodDirectiveParameters<Value>

#### Hierarchy (View Summary)

- ExtractResolveMethodMixin
- ExtractIsValueFunctionMixin
- ExtractToDisplayFunctionMixin
- AfterViewInit
- OnDestroy
- OptionsFromMethodDirective<Value, Parameters>
  - AutocompleteOptionsFromMethodDirective

#### Implements

- AfterViewInit
- OnDestroy

- Defined in packages/angular/form-system/src/lib/directives/autocomplete-options-from-method.directive.ts:96
- Defined in packages/angular/form-system/src/lib/directives/autocomplete-options-from-method.directive.ts:115

#####
Index

### Constructors

constructor

### Properties

cdr
control?
injector
isValue?
matAutocomplete?
matFormField
method
ngControl
options
parameters?
resetOnChange?
resolveMethod?
settings
toDisplay?
viewContainerRef

### Methods

extractControl
extractFormDefinition
extractFunction
extractFunctions
extractIsValueFunction
extractMethod
extractMethods
extractOptionsMethod
extractResolveMethod
extractToDisplayFunction
loadOptions
ngAfterViewInit
ngOnChanges
ngOnDestroy
renderTemplate
resolveValue
setOptions
ngTemplateContextGuard

##
Constructors

### constructor

- new AutocompleteOptionsFromMethodDirective<
  Value = any,
  Parameters extends
  AutocompleteOptionsFromMethodDirectiveParameters<Value> = AutocompleteOptionsFromMethodDirectiveParameters<
  Value,
  >,
  >(): AutocompleteOptionsFromMethodDirective<Value, Parameters>

  #### Type Parameters

  - Value = any
  - Parameters extends AutocompleteOptionsFromMethodDirectiveParameters<Value> = AutocompleteOptionsFromMethodDirectiveParameters<Value>

  #### Returns AutocompleteOptionsFromMethodDirective<Value, Parameters>

  Inherited from OptionsFromMethodDirective.constructor

##
Properties

### `Protected` `Readonly` cdr

cdr: ChangeDetectorRef = ...

Inherited from OptionsFromMethodDirective.cdr

- Defined in packages/angular/form-system/src/lib/directives/options-from-method.directive.ts:73

### `Protected` `Optional` control

control?: RxapFormControl<any, any, any>

Inherited from OptionsFromMethodDirective.control

- Defined in packages/angular/form-system/src/lib/mixins/extract-control.mixin.ts:14

### `Protected` injector

injector: Injector = ...

Inherited from OptionsFromMethodDirective.injector

- Defined in packages/angular/form-system/src/lib/directives/autocomplete-options-from-method.directive.ts:147

### `Optional` isValue

isValue?: (value: any) => boolean

- Defined in packages/angular/form-system/src/lib/directives/autocomplete-options-from-method.directive.ts:140

### `Optional` matAutocomplete

matAutocomplete?: MatAutocomplete

- Defined in packages/angular/form-system/src/lib/directives/autocomplete-options-from-method.directive.ts:131

### `Protected` matFormField

matFormField: null | MatFormField = null

Inherited from OptionsFromMethodDirective.matFormField

- Defined in packages/angular/form-system/src/lib/directives/autocomplete-options-from-method.directive.ts:146

### method

method: Method<ControlOptions, Parameters>

Inherited from OptionsFromMethodDirective.method

- Defined in packages/angular/form-system/src/lib/directives/autocomplete-options-from-method.directive.ts:134

### `Protected` ngControl

ngControl: null | NgControl = null

Inherited from OptionsFromMethodDirective.ngControl

- Defined in packages/angular/form-system/src/lib/directives/autocomplete-options-from-method.directive.ts:145

### options

options: null | ControlOptions = null

Inherited from OptionsFromMethodDirective.options

- Defined in packages/angular/form-system/src/lib/directives/options-from-method.directive.ts:64

### `Optional` parameters

parameters?: Parameters

Inherited from OptionsFromMethodDirective.parameters

- Defined in packages/angular/form-system/src/lib/directives/autocomplete-options-from-method.directive.ts:127

### `Optional` resetOnChange

resetOnChange?: Value

Inherited from OptionsFromMethodDirective.resetOnChange

- Defined in packages/angular/form-system/src/lib/directives/autocomplete-options-from-method.directive.ts:129

### `Optional` resolveMethod

resolveMethod?: MethodWithParameters<
ControlOption<any, string>,
{ value: Value } & Parameters,
>

- Defined in packages/angular/form-system/src/lib/directives/autocomplete-options-from-method.directive.ts:137

### `Protected` settings

settings: AutocompleteOptionsFromMethodDirectiveSettings = {}

Inherited from OptionsFromMethodDirective.settings

- Defined in packages/angular/form-system/src/lib/directives/autocomplete-options-from-method.directive.ts:148

### `Optional` toDisplay

toDisplay?: (value: any) => string

- Defined in packages/angular/form-system/src/lib/directives/autocomplete-options-from-method.directive.ts:143

### `Protected` `Readonly` viewContainerRef

viewContainerRef: ViewContainerRef = ...

Inherited from OptionsFromMethodDirective.viewContainerRef

- Defined in packages/angular/form-system/src/lib/directives/options-from-method.directive.ts:71

##
Methods

### `Protected` extractControl

- extractControl(
  ngControl?: null | NgControl | AbstractControlDirective,
  ): RxapFormControl

  #### Parameters

  - ngControl: null | NgControl | AbstractControlDirective = ...

  #### Returns RxapFormControl

  Inherited from OptionsFromMethodDirective.extractControl

  - Defined in packages/angular/form-system/src/lib/mixins/extract-control.mixin.ts:16

### `Protected` extractFormDefinition

- extractFormDefinition(control: AbstractControl): FormDefinition

  #### Parameters

  - control: AbstractControl

  #### Returns FormDefinition

  Inherited from OptionsFromMethodDirective.extractFormDefinition

  - Defined in packages/angular/form-system/src/lib/mixins/extract-form-definition.mixin.ts:10

### extractFunction

- extractFunction<Args extends any[], Result>(
  defaultFunction?: null | UseFunctionType<Args, Result>,
  formDefinition: FormDefinition,
  controlId: string,
  name: string,
  ): UseFunctionType<Args, Result>

  #### Type Parameters

  - Args extends any[]
  - Result

  #### Parameters

  - defaultFunction: null | UseFunctionType<Args, Result> = null
  - formDefinition: FormDefinition
  - controlId: string
  - name: string

  #### Returns UseFunctionType<Args, Result>

  Inherited from ExtractToDisplayFunctionMixin.extractFunction

  - Defined in packages/angular/form-system/src/lib/mixins/extract-function.mixin.ts:20

### `Protected` extractFunctions

- extractFunctions(
  defaultMap?:
  | null
  | Map<
  string,
  UseFunctionDefinition<
  unknown,
  any[],
  UseFunctionConfig<unknown, any[], any, any[]>,
  >,
  >,
  formDefinition: FormDefinition,
  controlId: string,
  ): Map<
  string,
  UseFunctionDefinition<
  unknown,
  any[],
  UseFunctionConfig<unknown, any[], any, any[]>,
  >,
  >

  #### Parameters

  - defaultMap:
    | null
    | Map<
    string,
    UseFunctionDefinition<
    unknown,
    any[],
    UseFunctionConfig<unknown, any[], any, any[]>,
    >,
    > = null
  - formDefinition: FormDefinition
  - controlId: string

  #### Returns Map<
  string,
  UseFunctionDefinition<
  unknown,
  any[],
  UseFunctionConfig<unknown, any[], any, any[]>,
  >,
  >

  Inherited from ExtractToDisplayFunctionMixin.extractFunctions

  - Defined in packages/angular/form-system/src/lib/mixins/extract-functions.mixin.ts:43

### `Protected` extractIsValueFunction

- extractIsValueFunction(
  defaultFunction?: null | UseFunctionType<[any], boolean>,
  control?: RxapFormControl,
  formDefinition?: FormDefinition<any, any, any>,
  ): UseFunctionType<[any], boolean>

  #### Parameters

  - defaultFunction: null | UseFunctionType<[any], boolean> = null
  - control: RxapFormControl = ...
  - formDefinition: FormDefinition<any, any, any> = ...

  #### Returns UseFunctionType<[any], boolean>

  Inherited from ExtractIsValueFunctionMixin.extractIsValueFunction

  - Defined in packages/angular/form-system/src/lib/mixins/extract-is-value-function.mixin.ts:38

### extractMethod

- extractMethod(
  formDefinition: FormDefinition,
  controlId: string,
  name: string,
  ): Method<any, any>

  #### Parameters

  - formDefinition: FormDefinition
  - controlId: string
  - name: string

  #### Returns Method<any, any>

  Inherited from OptionsFromMethodDirective.extractMethod

  - Defined in packages/angular/form-system/src/lib/mixins/extract-method.mixin.ts:16

### `Protected` extractMethods

- extractMethods(
  formDefinition: FormDefinition,
  controlId: string,
  ): Map<
  string,
  UseMethodDefinition<
  unknown,
  unknown,
  UseMethodConfig<unknown, unknown, any, any>,
  >,
  >

  #### Parameters

  - formDefinition: FormDefinition
  - controlId: string

  #### Returns Map<
  string,
  UseMethodDefinition<
  unknown,
  unknown,
  UseMethodConfig<unknown, unknown, any, any>,
  >,
  >

  Inherited from OptionsFromMethodDirective.extractMethods

  - Defined in packages/angular/form-system/src/lib/mixins/extract-methods.mixin.ts:43

### `Protected` extractOptionsMethod

- extractOptionsMethod(
  control?: RxapFormControl,
  formDefinition?: FormDefinition<any, any, any>,
  ): Method<any, any>

  #### Parameters

  - control: RxapFormControl = ...
  - formDefinition: FormDefinition<any, any, any> = ...

  #### Returns Method<any, any>

  Inherited from OptionsFromMethodDirective.extractOptionsMethod

  - Defined in packages/angular/form-system/src/lib/mixins/extract-options-method.mixin.ts:29

### `Protected` extractResolveMethod

- extractResolveMethod(
  control?: RxapFormControl,
  formDefinition?: FormDefinition<any, any, any>,
  ): Method<any, any>

  #### Parameters

  - control: RxapFormControl = ...
  - formDefinition: FormDefinition<any, any, any> = ...

  #### Returns Method<any, any>

  Inherited from ExtractResolveMethodMixin.extractResolveMethod

  - Defined in packages/angular/form-system/src/lib/mixins/extract-resolve-method.mixin.ts:39

### `Protected` extractToDisplayFunction

- extractToDisplayFunction(
  defaultFunction?: null | UseFunctionType<[any], string>,
  control?: RxapFormControl,
  formDefinition?: FormDefinition<any, any, any>,
  ): UseFunctionType<[any], string>

  #### Parameters

  - defaultFunction: null | UseFunctionType<[any], string> = null
  - control: RxapFormControl = ...
  - formDefinition: FormDefinition<any, any, any> = ...

  #### Returns UseFunctionType<[any], string>

  Inherited from ExtractToDisplayFunctionMixin.extractToDisplayFunction

  - Defined in packages/angular/form-system/src/lib/mixins/extract-to-display-function.mixin.ts:38

### `Protected` loadOptions

- loadOptions(parameters?: Parameters): Promise<null | ControlOptions>

  #### Parameters

  - parameters: Parameters = ...

  #### Returns Promise<null | ControlOptions>

  Inherited from OptionsFromMethodDirective.loadOptions

  - Defined in packages/angular/form-system/src/lib/directives/autocomplete-options-from-method.directive.ts:201

### ngAfterViewInit

- ngAfterViewInit(): Promise<void>

  A callback method that is invoked immediately after Angular has completed initialization of a component's view. It is invoked only once when the view is instantiated.

  #### Returns Promise<void>

  Inherited from OptionsFromMethodDirective.ngAfterViewInit

  - Defined in packages/angular/form-system/src/lib/directives/autocomplete-options-from-method.directive.ts:164

### ngOnChanges

- ngOnChanges(changes: SimpleChanges): Promise<void>

  A callback method that is invoked immediately after the default change detector has checked data-bound properties if at least one has changed, and before the view and content children are checked.

  #### Parameters

  - changes: SimpleChanges

    The changed properties.

  #### Returns Promise<void>

  Inherited from OptionsFromMethodDirective.ngOnChanges

  - Defined in packages/angular/form-system/src/lib/directives/options-from-method.directive.ts:88

### ngOnDestroy

- ngOnDestroy(): void

  A callback method that performs custom clean-up, invoked immediately before a directive, pipe, or service instance is destroyed.

  #### Returns void

  Inherited from OnDestroy.ngOnDestroy

  - Defined in packages/angular/form-system/src/lib/directives/autocomplete-options-from-method.directive.ts:160

### `Protected` renderTemplate

- renderTemplate(): void

  #### Returns void

  Inherited from OptionsFromMethodDirective.renderTemplate

  - Defined in packages/angular/form-system/src/lib/directives/autocomplete-options-from-method.directive.ts:218

### `Protected` resolveValue

- resolveValue(
  value: Value,
  parameters?: Parameters,
  ): Promise<null | ControlOptions>

  #### Parameters

  - value: Value
  - parameters: Parameters = ...

  #### Returns Promise<null | ControlOptions>

  - Defined in packages/angular/form-system/src/lib/directives/autocomplete-options-from-method.directive.ts:226

### `Protected` setOptions

- setOptions(options: null | ControlOptions): void

  #### Parameters

  - options: null | ControlOptions

  #### Returns void

  Inherited from OptionsFromMethodDirective.setOptions

  - Defined in packages/angular/form-system/src/lib/directives/options-from-method.directive.ts:125

### `Static` ngTemplateContextGuard

- ngTemplateContextGuard(
  dir: OptionsFromMethodDirective,
  ctx: any,
  ): ctx is AutocompleteOptionsFromRemoteMethodTemplateContext

  #### Parameters

  - dir: OptionsFromMethodDirective
  - ctx: any

  #### Returns ctx is AutocompleteOptionsFromRemoteMethodTemplateContext

  Inherited from OptionsFromMethodDirective.ngTemplateContextGuard

  - Defined in packages/angular/form-system/src/lib/directives/autocomplete-options-from-method.directive.ts:119